/* C test program: Tests writing records to a file, then
   reading them back. Note: In GCCMU, enter the ddname when
   prompted for file name.
   Also tests sprintf().
*/

#include <stdio.h>
#include <string.h>

int main(int numarg, char *cmdarg[])
{
FILE *fptr;
unsigned char ch,*fn,bf[100];
int n1,n2,chn;
int debugsw=1;  /* normally 0, set to nonzero for debugging msgs */

if(numarg<2)
  { printf("Usage:  tstwrite filename\n");
    printf("NOTE: For GCCMU, enter a ddname instead of filename\n");
    return 1;
  }
fn=cmdarg[1];

fptr=fopen(fn,"w");
if(fptr==NULL)
  { printf("Unable to open file %s for writing\n",fn);
    return 2;
  }

fprintf(fptr,"Output record 1.\n");
fprintf(fptr,"Output record 2222.\n");
fprintf(fptr,"Output record 33.\n");
printf("3 records written to file %s\n",fn);

n2=-123;
n1=sprintf(bf,"Value of n2 is %d",n2);
printf("\nsprintf() returned n1=%d\n",n1);
n2=strlen(bf);
printf("bf=|%s| len=%d\n",bf,n2);
printf("\n");

if(fclose(fptr))  /* close the file */
  { printf("Error closing the file after writing\n");
  }

/* Read the record back from the file */
fptr=fopen(fn,"r");
if(fptr==NULL)
  { printf("Unable to open file %s for reading\n",fn);
    return 2;
  }
printf("Reading data back from the file:\n");
for(n1=0;;n1++)
  { chn=fgetc(fptr);
    if(chn==EOF) { printf("EOF\n"); break; }
    ch=(unsigned char)chn;
    printf("%c",ch);
  }
printf(" %d chars read from file\n",n1);
if(fclose(fptr))  /* close the file */
  { printf("Error closing the file after reading\n");
  }

return 0;
}  /* end of main */
